"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// index.typings.ts
var index_typings_exports = {};
__export(index_typings_exports, {
  Action: () => Action,
  AddressTag: () => AddressTag,
  ContactActivityType: () => ContactActivityType,
  ContactFieldSet: () => ContactFieldSet,
  ContactSourceType: () => ContactSourceType,
  ContactsFacetType: () => ContactsFacetType,
  EmailDeliverabilityStatus: () => EmailDeliverabilityStatus,
  EmailTag: () => EmailTag,
  GetContactResponseType: () => GetContactResponseType,
  ImageProvider: () => ImageProvider,
  MemberStatus: () => MemberStatus,
  Mode: () => Mode,
  PhoneDeliverabilityStatus: () => PhoneDeliverabilityStatus,
  PhoneTag: () => PhoneTag,
  PrivacyStatus: () => PrivacyStatus,
  Role: () => Role,
  SortOrder: () => SortOrder,
  SubdivisionType: () => SubdivisionType,
  SubmitOperation: () => SubmitOperation,
  SubscriptionStatus: () => SubscriptionStatus,
  UpsertContactResponseAction: () => UpsertContactResponseAction,
  WebhookIdentityType: () => WebhookIdentityType,
  createContact: () => createContact2,
  deleteContact: () => deleteContact2,
  getContact: () => getContact2,
  labelContact: () => labelContact2,
  mergeContacts: () => mergeContacts2,
  queryContacts: () => queryContacts2,
  unlabelContact: () => unlabelContact2,
  updateContact: () => updateContact2
});
module.exports = __toCommonJS(index_typings_exports);

// src/contacts-v4-contact-contacts.universal.ts
var import_transform_error = require("@wix/sdk-runtime/transform-error");
var import_query_builder = require("@wix/sdk-runtime/query-builder");
var import_rename_all_nested_keys = require("@wix/sdk-runtime/rename-all-nested-keys");

// src/contacts-v4-contact-contacts.http.ts
var import_rest_modules = require("@wix/sdk-runtime/rest-modules");
var import_float = require("@wix/sdk-runtime/transformations/float");
var import_float2 = require("@wix/sdk-runtime/transformations/float");
var import_timestamp = require("@wix/sdk-runtime/transformations/timestamp");
var import_timestamp2 = require("@wix/sdk-runtime/transformations/timestamp");
var import_field_mask = require("@wix/sdk-runtime/transformations/field-mask");
var import_transform_paths = require("@wix/sdk-runtime/transformations/transform-paths");
var import_rest_modules2 = require("@wix/sdk-runtime/rest-modules");
function resolveComWixpressContactsCoreApiV4ContactsServiceV4Url(opts) {
  const domainToMappings = {
    "www._base_domain_": [
      {
        srcPath: "/_api/contacts/v4/contacts",
        destPath: "/v4/contacts"
      },
      {
        srcPath: "/_api/contacts/v4/bulk",
        destPath: "/v4/bulk"
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/contacts/v4/contacts",
        destPath: "/v4/contacts"
      },
      {
        srcPath: "/contacts/v4/bulk",
        destPath: "/v4/bulk"
      }
    ],
    "manage._base_domain_": [
      {
        srcPath: "/_api/contacts/v4/contacts",
        destPath: "/v4/contacts"
      },
      {
        srcPath: "/_api/contacts/v4/bulk",
        destPath: "/v4/bulk"
      }
    ],
    "manage.nownia.com": [
      {
        srcPath: "/_api/contacts/v4/contacts",
        destPath: "/v4/contacts"
      },
      {
        srcPath: "/_api/contacts/v4/bulk",
        destPath: "/v4/bulk"
      }
    ],
    _: [
      {
        srcPath: "/_api/contacts/v4/bulk",
        destPath: "/v4/bulk"
      },
      {
        srcPath: "/_api/contacts/v4/contacts",
        destPath: "/v4/contacts"
      }
    ],
    "*.dev.wix-code.com": [
      {
        srcPath: "/_api/contacts/v4/bulk",
        destPath: "/v4/bulk"
      },
      {
        srcPath: "/_api/contacts/v4/contacts",
        destPath: "/v4/contacts"
      }
    ]
  };
  return (0, import_rest_modules2.resolveUrl)(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_crm_contacts";
function createContact(payload) {
  function __createContact({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_float.transformSDKFloatToRESTFloat,
        paths: [
          { path: "info.addresses.items.address.geocode.latitude" },
          { path: "info.addresses.items.address.geocode.longitude" }
        ]
      },
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [{ path: "info.picture.image.urlExpirationDate" }]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.contacts.v4.contact",
      method: "POST",
      methodFqn: "com.wixpress.contacts.core.api.v4.ContactsServiceV4.CreateContact",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsCoreApiV4ContactsServiceV4Url({
        protoPath: "/v4/contacts",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "contact.createdDate" },
            { path: "contact.updatedDate" },
            { path: "contact.lastActivity.activityDate" },
            { path: "contact.lastActivity.date" },
            { path: "contact.picture.urlExpirationDate" },
            { path: "contact.info.picture.image.urlExpirationDate" },
            { path: "contact.memberInfo.signupDate" },
            {
              path: "contact.memberInfo.profileInfo.photo.urlExpirationDate"
            },
            { path: "contact.memberInfo.sessionInfo.lastWebLogin" },
            { path: "contact.memberInfo.sessionInfo.lastMobileLogin" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            { path: "contact.info.addresses.items.address.geocode.latitude" },
            {
              path: "contact.info.addresses.items.address.geocode.longitude"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __createContact;
}
function updateContact(payload) {
  function __updateContact({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_field_mask.transformSDKFieldMaskToRESTFieldMask,
        paths: [{ path: "fieldMask" }]
      },
      {
        transformFn: import_float.transformSDKFloatToRESTFloat,
        paths: [
          { path: "info.addresses.items.address.geocode.latitude" },
          { path: "info.addresses.items.address.geocode.longitude" }
        ]
      },
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [{ path: "info.picture.image.urlExpirationDate" }]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.contacts.v4.contact",
      method: "PATCH",
      methodFqn: "com.wixpress.contacts.core.api.v4.ContactsServiceV4.UpdateContact",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsCoreApiV4ContactsServiceV4Url({
        protoPath: "/v4/contacts/{contactId}",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "contact.createdDate" },
            { path: "contact.updatedDate" },
            { path: "contact.lastActivity.activityDate" },
            { path: "contact.lastActivity.date" },
            { path: "contact.picture.urlExpirationDate" },
            { path: "contact.info.picture.image.urlExpirationDate" },
            { path: "contact.memberInfo.signupDate" },
            {
              path: "contact.memberInfo.profileInfo.photo.urlExpirationDate"
            },
            { path: "contact.memberInfo.sessionInfo.lastWebLogin" },
            { path: "contact.memberInfo.sessionInfo.lastMobileLogin" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            { path: "contact.info.addresses.items.address.geocode.latitude" },
            {
              path: "contact.info.addresses.items.address.geocode.longitude"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __updateContact;
}
function mergeContacts(payload) {
  function __mergeContacts({ host }) {
    const metadata = {
      entityFqdn: "wix.contacts.v4.contact",
      method: "POST",
      methodFqn: "com.wixpress.contacts.core.api.v4.ContactsServiceV4.MergeContacts",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsCoreApiV4ContactsServiceV4Url({
        protoPath: "/v4/contacts/{targetContactId}/merge",
        data: payload,
        host
      }),
      data: payload,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "contact.createdDate" },
            { path: "contact.updatedDate" },
            { path: "contact.lastActivity.activityDate" },
            { path: "contact.lastActivity.date" },
            { path: "contact.picture.urlExpirationDate" },
            { path: "contact.info.picture.image.urlExpirationDate" },
            { path: "contact.memberInfo.signupDate" },
            {
              path: "contact.memberInfo.profileInfo.photo.urlExpirationDate"
            },
            { path: "contact.memberInfo.sessionInfo.lastWebLogin" },
            { path: "contact.memberInfo.sessionInfo.lastMobileLogin" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            { path: "contact.info.addresses.items.address.geocode.latitude" },
            {
              path: "contact.info.addresses.items.address.geocode.longitude"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __mergeContacts;
}
function deleteContact(payload) {
  function __deleteContact({ host }) {
    const metadata = {
      entityFqdn: "wix.contacts.v4.contact",
      method: "DELETE",
      methodFqn: "com.wixpress.contacts.core.api.v4.ContactsServiceV4.DeleteContact",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsCoreApiV4ContactsServiceV4Url({
        protoPath: "/v4/contacts/{contactId}",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload)
    };
    return metadata;
  }
  return __deleteContact;
}
function labelContact(payload) {
  function __labelContact({ host }) {
    const metadata = {
      entityFqdn: "wix.contacts.v4.contact",
      method: "POST",
      methodFqn: "com.wixpress.contacts.core.api.v4.ContactsServiceV4.LabelContact",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsCoreApiV4ContactsServiceV4Url({
        protoPath: "/v4/contacts/{contactId}/labels",
        data: payload,
        host
      }),
      data: payload,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "contact.createdDate" },
            { path: "contact.updatedDate" },
            { path: "contact.lastActivity.activityDate" },
            { path: "contact.lastActivity.date" },
            { path: "contact.picture.urlExpirationDate" },
            { path: "contact.info.picture.image.urlExpirationDate" },
            { path: "contact.memberInfo.signupDate" },
            {
              path: "contact.memberInfo.profileInfo.photo.urlExpirationDate"
            },
            { path: "contact.memberInfo.sessionInfo.lastWebLogin" },
            { path: "contact.memberInfo.sessionInfo.lastMobileLogin" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            { path: "contact.info.addresses.items.address.geocode.latitude" },
            {
              path: "contact.info.addresses.items.address.geocode.longitude"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __labelContact;
}
function unlabelContact(payload) {
  function __unlabelContact({ host }) {
    const metadata = {
      entityFqdn: "wix.contacts.v4.contact",
      method: "DELETE",
      methodFqn: "com.wixpress.contacts.core.api.v4.ContactsServiceV4.UnlabelContact",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsCoreApiV4ContactsServiceV4Url({
        protoPath: "/v4/contacts/{contactId}/labels",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload),
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "contact.createdDate" },
            { path: "contact.updatedDate" },
            { path: "contact.lastActivity.activityDate" },
            { path: "contact.lastActivity.date" },
            { path: "contact.picture.urlExpirationDate" },
            { path: "contact.info.picture.image.urlExpirationDate" },
            { path: "contact.memberInfo.signupDate" },
            {
              path: "contact.memberInfo.profileInfo.photo.urlExpirationDate"
            },
            { path: "contact.memberInfo.sessionInfo.lastWebLogin" },
            { path: "contact.memberInfo.sessionInfo.lastMobileLogin" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            { path: "contact.info.addresses.items.address.geocode.latitude" },
            {
              path: "contact.info.addresses.items.address.geocode.longitude"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __unlabelContact;
}
function queryContacts(payload) {
  function __queryContacts({ host }) {
    const metadata = {
      entityFqdn: "wix.contacts.v4.contact",
      method: "POST",
      methodFqn: "com.wixpress.contacts.core.api.v4.ContactsServiceV4.QueryContacts",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsCoreApiV4ContactsServiceV4Url({
        protoPath: "/v4/contacts/query",
        data: payload,
        host
      }),
      data: payload,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "contacts.createdDate" },
            { path: "contacts.updatedDate" },
            { path: "contacts.lastActivity.activityDate" },
            { path: "contacts.lastActivity.date" },
            { path: "contacts.picture.urlExpirationDate" },
            { path: "contacts.info.picture.image.urlExpirationDate" },
            { path: "contacts.memberInfo.signupDate" },
            {
              path: "contacts.memberInfo.profileInfo.photo.urlExpirationDate"
            },
            { path: "contacts.memberInfo.sessionInfo.lastWebLogin" },
            { path: "contacts.memberInfo.sessionInfo.lastMobileLogin" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            {
              path: "contacts.info.addresses.items.address.geocode.latitude"
            },
            {
              path: "contacts.info.addresses.items.address.geocode.longitude"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __queryContacts;
}
function getContact(payload) {
  function __getContact({ host }) {
    const metadata = {
      entityFqdn: "wix.contacts.v4.contact",
      method: "GET",
      methodFqn: "com.wixpress.contacts.core.api.v4.ContactsServiceV4.GetContact",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsCoreApiV4ContactsServiceV4Url({
        protoPath: "/v4/contacts/{id}",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload),
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "contact.createdDate" },
            { path: "contact.updatedDate" },
            { path: "contact.lastActivity.activityDate" },
            { path: "contact.lastActivity.date" },
            { path: "contact.picture.urlExpirationDate" },
            { path: "contact.info.picture.image.urlExpirationDate" },
            { path: "contact.memberInfo.signupDate" },
            {
              path: "contact.memberInfo.profileInfo.photo.urlExpirationDate"
            },
            { path: "contact.memberInfo.sessionInfo.lastWebLogin" },
            { path: "contact.memberInfo.sessionInfo.lastMobileLogin" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            { path: "contact.info.addresses.items.address.geocode.latitude" },
            {
              path: "contact.info.addresses.items.address.geocode.longitude"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __getContact;
}

// src/contacts-v4-contact-contacts.universal.ts
var import_address = require("@wix/sdk-runtime/transformations/address");
var import_address2 = require("@wix/sdk-runtime/transformations/address");
var import_image = require("@wix/sdk-runtime/transformations/image");
var import_image2 = require("@wix/sdk-runtime/transformations/image");
var import_transform_paths2 = require("@wix/sdk-runtime/transformations/transform-paths");
var ContactSourceType = /* @__PURE__ */ ((ContactSourceType2) => {
  ContactSourceType2["OTHER"] = "OTHER";
  ContactSourceType2["ADMIN"] = "ADMIN";
  ContactSourceType2["WIX_APP"] = "WIX_APP";
  ContactSourceType2["IMPORT"] = "IMPORT";
  ContactSourceType2["THIRD_PARTY"] = "THIRD_PARTY";
  ContactSourceType2["WIX_BOOKINGS"] = "WIX_BOOKINGS";
  ContactSourceType2["WIX_CHAT"] = "WIX_CHAT";
  ContactSourceType2["WIX_EMAIL_MARKETING"] = "WIX_EMAIL_MARKETING";
  ContactSourceType2["WIX_EVENTS"] = "WIX_EVENTS";
  ContactSourceType2["WIX_FORMS"] = "WIX_FORMS";
  ContactSourceType2["WIX_GROUPS"] = "WIX_GROUPS";
  ContactSourceType2["WIX_HOTELS"] = "WIX_HOTELS";
  ContactSourceType2["WIX_MARKET_PLACE"] = "WIX_MARKET_PLACE";
  ContactSourceType2["WIX_MUSIC"] = "WIX_MUSIC";
  ContactSourceType2["WIX_RESTAURANTS"] = "WIX_RESTAURANTS";
  ContactSourceType2["WIX_SITE_MEMBERS"] = "WIX_SITE_MEMBERS";
  ContactSourceType2["WIX_STORES"] = "WIX_STORES";
  ContactSourceType2["WIX_CODE"] = "WIX_CODE";
  ContactSourceType2["HOPP"] = "HOPP";
  return ContactSourceType2;
})(ContactSourceType || {});
var ContactActivityType = /* @__PURE__ */ ((ContactActivityType2) => {
  ContactActivityType2["GENERAL"] = "GENERAL";
  ContactActivityType2["CONTACT_CREATED"] = "CONTACT_CREATED";
  ContactActivityType2["MEMBER_LOGIN"] = "MEMBER_LOGIN";
  ContactActivityType2["MEMBER_REGISTER"] = "MEMBER_REGISTER";
  ContactActivityType2["MEMBER_STATUS_CHANGED"] = "MEMBER_STATUS_CHANGED";
  ContactActivityType2["FORM_SUBMITTED"] = "FORM_SUBMITTED";
  ContactActivityType2["INBOX_FORM_SUBMITTED"] = "INBOX_FORM_SUBMITTED";
  ContactActivityType2["INBOX_PAYMENT_REQUEST_PAID"] = "INBOX_PAYMENT_REQUEST_PAID";
  ContactActivityType2["INBOX_MESSAGE_TO_CUSTOMER"] = "INBOX_MESSAGE_TO_CUSTOMER";
  ContactActivityType2["INBOX_MESSAGE_FROM_CUSTOMER"] = "INBOX_MESSAGE_FROM_CUSTOMER";
  ContactActivityType2["NEWSLETTER_SUBSCRIPTION_FORM_SUBMITTED"] = "NEWSLETTER_SUBSCRIPTION_FORM_SUBMITTED";
  ContactActivityType2["NEWSLETTER_SUBSCRIPTION_UNSUBSCRIBE"] = "NEWSLETTER_SUBSCRIPTION_UNSUBSCRIBE";
  ContactActivityType2["ECOM_PURCHASE"] = "ECOM_PURCHASE";
  ContactActivityType2["ECOM_CART_ABANDON"] = "ECOM_CART_ABANDON";
  ContactActivityType2["ECOM_CHECKOUT_BUYER"] = "ECOM_CHECKOUT_BUYER";
  ContactActivityType2["BOOKINGS_APPOINTMENT"] = "BOOKINGS_APPOINTMENT";
  ContactActivityType2["HOTELS_RESERVATION"] = "HOTELS_RESERVATION";
  ContactActivityType2["HOTELS_PURCHASE"] = "HOTELS_PURCHASE";
  ContactActivityType2["HOTELS_CONFIRMATION"] = "HOTELS_CONFIRMATION";
  ContactActivityType2["HOTELS_CANCEL"] = "HOTELS_CANCEL";
  ContactActivityType2["VIDEO_PURCHASE"] = "VIDEO_PURCHASE";
  ContactActivityType2["VIDEO_RENT"] = "VIDEO_RENT";
  ContactActivityType2["CASHIER_BUTTON_PURCHASE"] = "CASHIER_BUTTON_PURCHASE";
  ContactActivityType2["ARENA_NEW_LEAD"] = "ARENA_NEW_LEAD";
  ContactActivityType2["EVENTS_RSVP"] = "EVENTS_RSVP";
  ContactActivityType2["INVOICE_PAY"] = "INVOICE_PAY";
  ContactActivityType2["INVOICE_OVERDUE"] = "INVOICE_OVERDUE";
  ContactActivityType2["PRICE_QUOTE_ACCEPT"] = "PRICE_QUOTE_ACCEPT";
  ContactActivityType2["PRICE_QUOTE_EXPIRE"] = "PRICE_QUOTE_EXPIRE";
  ContactActivityType2["RESTAURANTS_ORDER"] = "RESTAURANTS_ORDER";
  ContactActivityType2["RESTAURANTS_RESERVATION"] = "RESTAURANTS_RESERVATION";
  ContactActivityType2["SHOUTOUT_OPEN"] = "SHOUTOUT_OPEN";
  ContactActivityType2["SHOUTOUT_CLICK"] = "SHOUTOUT_CLICK";
  ContactActivityType2["CONTACT_MERGED"] = "CONTACT_MERGED";
  ContactActivityType2["NEWSLETTER_SUBSCRIPTION_SUBSCRIBE"] = "NEWSLETTER_SUBSCRIPTION_SUBSCRIBE";
  ContactActivityType2["NEWSLETTER_SUBSCRIPTION_PENDING"] = "NEWSLETTER_SUBSCRIPTION_PENDING";
  ContactActivityType2["NEWSLETTER_SUBSCRIPTION_NOT_SET"] = "NEWSLETTER_SUBSCRIPTION_NOT_SET";
  ContactActivityType2["PHONE_SUBSCRIPTION_SUBSCRIBE"] = "PHONE_SUBSCRIPTION_SUBSCRIBE";
  ContactActivityType2["PHONE_SUBSCRIPTION_PENDING"] = "PHONE_SUBSCRIPTION_PENDING";
  ContactActivityType2["PHONE_SUBSCRIPTION_NOT_SET"] = "PHONE_SUBSCRIPTION_NOT_SET";
  ContactActivityType2["PHONE_SUBSCRIPTION_UNSUBSCRIBE"] = "PHONE_SUBSCRIPTION_UNSUBSCRIBE";
  return ContactActivityType2;
})(ContactActivityType || {});
var EmailTag = /* @__PURE__ */ ((EmailTag2) => {
  EmailTag2["UNTAGGED"] = "UNTAGGED";
  EmailTag2["MAIN"] = "MAIN";
  EmailTag2["HOME"] = "HOME";
  EmailTag2["WORK"] = "WORK";
  return EmailTag2;
})(EmailTag || {});
var PhoneTag = /* @__PURE__ */ ((PhoneTag2) => {
  PhoneTag2["UNTAGGED"] = "UNTAGGED";
  PhoneTag2["MAIN"] = "MAIN";
  PhoneTag2["HOME"] = "HOME";
  PhoneTag2["MOBILE"] = "MOBILE";
  PhoneTag2["WORK"] = "WORK";
  PhoneTag2["FAX"] = "FAX";
  return PhoneTag2;
})(PhoneTag || {});
var AddressTag = /* @__PURE__ */ ((AddressTag2) => {
  AddressTag2["UNTAGGED"] = "UNTAGGED";
  AddressTag2["HOME"] = "HOME";
  AddressTag2["WORK"] = "WORK";
  AddressTag2["BILLING"] = "BILLING";
  AddressTag2["SHIPPING"] = "SHIPPING";
  return AddressTag2;
})(AddressTag || {});
var SubdivisionType = /* @__PURE__ */ ((SubdivisionType2) => {
  SubdivisionType2["UNKNOWN_SUBDIVISION_TYPE"] = "UNKNOWN_SUBDIVISION_TYPE";
  SubdivisionType2["ADMINISTRATIVE_AREA_LEVEL_1"] = "ADMINISTRATIVE_AREA_LEVEL_1";
  SubdivisionType2["ADMINISTRATIVE_AREA_LEVEL_2"] = "ADMINISTRATIVE_AREA_LEVEL_2";
  SubdivisionType2["ADMINISTRATIVE_AREA_LEVEL_3"] = "ADMINISTRATIVE_AREA_LEVEL_3";
  SubdivisionType2["ADMINISTRATIVE_AREA_LEVEL_4"] = "ADMINISTRATIVE_AREA_LEVEL_4";
  SubdivisionType2["ADMINISTRATIVE_AREA_LEVEL_5"] = "ADMINISTRATIVE_AREA_LEVEL_5";
  SubdivisionType2["COUNTRY"] = "COUNTRY";
  return SubdivisionType2;
})(SubdivisionType || {});
var ImageProvider = /* @__PURE__ */ ((ImageProvider2) => {
  ImageProvider2["UNKNOWN"] = "UNKNOWN";
  ImageProvider2["EXTERNAL"] = "EXTERNAL";
  ImageProvider2["WIX_MEDIA"] = "WIX_MEDIA";
  return ImageProvider2;
})(ImageProvider || {});
var SubscriptionStatus = /* @__PURE__ */ ((SubscriptionStatus2) => {
  SubscriptionStatus2["NO_SUBSCRIPTION_STATUS"] = "NO_SUBSCRIPTION_STATUS";
  SubscriptionStatus2["NOT_SET"] = "NOT_SET";
  SubscriptionStatus2["PENDING"] = "PENDING";
  SubscriptionStatus2["SUBSCRIBED"] = "SUBSCRIBED";
  SubscriptionStatus2["UNSUBSCRIBED"] = "UNSUBSCRIBED";
  return SubscriptionStatus2;
})(SubscriptionStatus || {});
var EmailDeliverabilityStatus = /* @__PURE__ */ ((EmailDeliverabilityStatus2) => {
  EmailDeliverabilityStatus2["NOT_SET"] = "NOT_SET";
  EmailDeliverabilityStatus2["VALID"] = "VALID";
  EmailDeliverabilityStatus2["BOUNCED"] = "BOUNCED";
  EmailDeliverabilityStatus2["SPAM_COMPLAINT"] = "SPAM_COMPLAINT";
  EmailDeliverabilityStatus2["INACTIVE"] = "INACTIVE";
  return EmailDeliverabilityStatus2;
})(EmailDeliverabilityStatus || {});
var PhoneDeliverabilityStatus = /* @__PURE__ */ ((PhoneDeliverabilityStatus2) => {
  PhoneDeliverabilityStatus2["NO_PHONE_DELIVERABILITY_STATUS"] = "NO_PHONE_DELIVERABILITY_STATUS";
  PhoneDeliverabilityStatus2["NOT_SET"] = "NOT_SET";
  return PhoneDeliverabilityStatus2;
})(PhoneDeliverabilityStatus || {});
var MemberStatus = /* @__PURE__ */ ((MemberStatus2) => {
  MemberStatus2["PENDING"] = "PENDING";
  MemberStatus2["ACTIVE"] = "ACTIVE";
  MemberStatus2["DELETED"] = "DELETED";
  MemberStatus2["BLOCKED"] = "BLOCKED";
  MemberStatus2["OFFLINE"] = "OFFLINE";
  return MemberStatus2;
})(MemberStatus || {});
var PrivacyStatus = /* @__PURE__ */ ((PrivacyStatus2) => {
  PrivacyStatus2["PRIVATE"] = "PRIVATE";
  PrivacyStatus2["PUBLIC"] = "PUBLIC";
  return PrivacyStatus2;
})(PrivacyStatus || {});
var Role = /* @__PURE__ */ ((Role2) => {
  Role2["UNSPECIFIED_ROLE"] = "UNSPECIFIED_ROLE";
  Role2["OWNER"] = "OWNER";
  Role2["CONTRIBUTOR"] = "CONTRIBUTOR";
  return Role2;
})(Role || {});
var SortOrder = /* @__PURE__ */ ((SortOrder2) => {
  SortOrder2["ASC"] = "ASC";
  SortOrder2["DESC"] = "DESC";
  return SortOrder2;
})(SortOrder || {});
var ContactFieldSet = /* @__PURE__ */ ((ContactFieldSet2) => {
  ContactFieldSet2["BASIC"] = "BASIC";
  ContactFieldSet2["COMMUNICATION_DETAILS"] = "COMMUNICATION_DETAILS";
  ContactFieldSet2["EXTENDED"] = "EXTENDED";
  ContactFieldSet2["FULL"] = "FULL";
  return ContactFieldSet2;
})(ContactFieldSet || {});
var ContactsFacetType = /* @__PURE__ */ ((ContactsFacetType2) => {
  ContactsFacetType2["UNKNOWN"] = "UNKNOWN";
  ContactsFacetType2["ALL_CONTACTS"] = "ALL_CONTACTS";
  ContactsFacetType2["NOT_LABELED"] = "NOT_LABELED";
  ContactsFacetType2["LABEL"] = "LABEL";
  ContactsFacetType2["SUBSCRIPTION_STATUS"] = "SUBSCRIPTION_STATUS";
  ContactsFacetType2["MEMBERSHIP_STATUS"] = "MEMBERSHIP_STATUS";
  return ContactsFacetType2;
})(ContactsFacetType || {});
var Action = /* @__PURE__ */ ((Action2) => {
  Action2["UNKNOWN"] = "UNKNOWN";
  Action2["UPDATED"] = "UPDATED";
  Action2["CREATED"] = "CREATED";
  return Action2;
})(Action || {});
var UpsertContactResponseAction = /* @__PURE__ */ ((UpsertContactResponseAction2) => {
  UpsertContactResponseAction2["UNKNOWN"] = "UNKNOWN";
  UpsertContactResponseAction2["UPDATED"] = "UPDATED";
  UpsertContactResponseAction2["CREATED"] = "CREATED";
  return UpsertContactResponseAction2;
})(UpsertContactResponseAction || {});
var GetContactResponseType = /* @__PURE__ */ ((GetContactResponseType2) => {
  GetContactResponseType2["REGULAR"] = "REGULAR";
  GetContactResponseType2["IMPLICIT"] = "IMPLICIT";
  GetContactResponseType2["MERGED"] = "MERGED";
  return GetContactResponseType2;
})(GetContactResponseType || {});
var SubmitOperation = /* @__PURE__ */ ((SubmitOperation2) => {
  SubmitOperation2["UNKNOWN"] = "UNKNOWN";
  SubmitOperation2["CREATE"] = "CREATE";
  SubmitOperation2["UPDATE"] = "UPDATE";
  return SubmitOperation2;
})(SubmitOperation || {});
var Mode = /* @__PURE__ */ ((Mode2) => {
  Mode2["OR"] = "OR";
  Mode2["AND"] = "AND";
  return Mode2;
})(Mode || {});
var WebhookIdentityType = /* @__PURE__ */ ((WebhookIdentityType2) => {
  WebhookIdentityType2["UNKNOWN"] = "UNKNOWN";
  WebhookIdentityType2["ANONYMOUS_VISITOR"] = "ANONYMOUS_VISITOR";
  WebhookIdentityType2["MEMBER"] = "MEMBER";
  WebhookIdentityType2["WIX_USER"] = "WIX_USER";
  WebhookIdentityType2["APP"] = "APP";
  return WebhookIdentityType2;
})(WebhookIdentityType || {});
async function createContact2(info, options) {
  const { httpClient, sideEffects } = arguments[2];
  const payload = (0, import_transform_paths2.transformPaths)(
    (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
      info,
      allowDuplicates: options?.allowDuplicates
    }),
    [
      {
        transformFn: import_address.transformSDKAddressToRESTAddress,
        paths: [{ path: "info.addresses.items.address" }]
      },
      {
        transformFn: import_image.transformSDKImageToRESTImage,
        paths: [{ path: "info.picture.image" }]
      }
    ]
  );
  const reqOpts = createContact(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(
      (0, import_transform_paths2.transformPaths)(result.data, [
        {
          transformFn: import_image2.transformRESTImageToSDKImage,
          paths: [
            { path: "contact.picture" },
            { path: "contact.info.picture.image" },
            { path: "contact.memberInfo.profileInfo.photo" }
          ]
        },
        {
          transformFn: import_address2.transformRESTAddressToSDKAddress,
          paths: [{ path: "contact.info.addresses.items.address" }]
        }
      ])
    );
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {
          info: "$[0]",
          allowDuplicates: "$[1].allowDuplicates"
        },
        singleArgumentUnchanged: false
      },
      ["info", "options"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function updateContact2(contactId, info, revision, options) {
  const { httpClient, sideEffects } = arguments[4];
  const payload = (0, import_transform_paths2.transformPaths)(
    (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
      contactId,
      info,
      revision,
      allowDuplicates: options?.allowDuplicates
    }),
    [
      {
        transformFn: import_address.transformSDKAddressToRESTAddress,
        paths: [{ path: "info.addresses.items.address" }]
      },
      {
        transformFn: import_image.transformSDKImageToRESTImage,
        paths: [{ path: "info.picture.image" }]
      }
    ]
  );
  const reqOpts = updateContact(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(
      (0, import_transform_paths2.transformPaths)(result.data, [
        {
          transformFn: import_image2.transformRESTImageToSDKImage,
          paths: [
            { path: "contact.picture" },
            { path: "contact.info.picture.image" },
            { path: "contact.memberInfo.profileInfo.photo" }
          ]
        },
        {
          transformFn: import_address2.transformRESTAddressToSDKAddress,
          paths: [{ path: "contact.info.addresses.items.address" }]
        }
      ])
    );
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {
          contactId: "$[0]",
          info: "$[1]",
          revision: "$[2]",
          allowDuplicates: "$[3].allowDuplicates"
        },
        singleArgumentUnchanged: false
      },
      ["contactId", "info", "revision", "options"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function mergeContacts2(targetContactId, targetContactRevision, options) {
  const { httpClient, sideEffects } = arguments[3];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    targetContactId,
    targetContactRevision,
    sourceContactIds: options?.sourceContactIds
  });
  const reqOpts = mergeContacts(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(
      (0, import_transform_paths2.transformPaths)(result.data, [
        {
          transformFn: import_image2.transformRESTImageToSDKImage,
          paths: [
            { path: "contact.picture" },
            { path: "contact.info.picture.image" },
            { path: "contact.memberInfo.profileInfo.photo" }
          ]
        },
        {
          transformFn: import_address2.transformRESTAddressToSDKAddress,
          paths: [{ path: "contact.info.addresses.items.address" }]
        }
      ])
    );
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {
          targetContactId: "$[0]",
          targetContactRevision: "$[1]",
          sourceContactIds: "$[2].sourceContactIds"
        },
        singleArgumentUnchanged: false
      },
      ["targetContactId", "targetContactRevision", "options"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function deleteContact2(contactId) {
  const { httpClient, sideEffects } = arguments[1];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    contactId
  });
  const reqOpts = deleteContact(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(result.data);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: { contactId: "$[0]" },
        singleArgumentUnchanged: false
      },
      ["contactId"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function labelContact2(contactId, labelKeys) {
  const { httpClient, sideEffects } = arguments[2];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    contactId,
    labelKeys
  });
  const reqOpts = labelContact(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(
      (0, import_transform_paths2.transformPaths)(result.data, [
        {
          transformFn: import_image2.transformRESTImageToSDKImage,
          paths: [
            { path: "contact.picture" },
            { path: "contact.info.picture.image" },
            { path: "contact.memberInfo.profileInfo.photo" }
          ]
        },
        {
          transformFn: import_address2.transformRESTAddressToSDKAddress,
          paths: [{ path: "contact.info.addresses.items.address" }]
        }
      ])
    );
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: { contactId: "$[0]", labelKeys: "$[1]" },
        singleArgumentUnchanged: false
      },
      ["contactId", "labelKeys"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function unlabelContact2(contactId, labelKeys) {
  const { httpClient, sideEffects } = arguments[2];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    contactId,
    labelKeys
  });
  const reqOpts = unlabelContact(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(
      (0, import_transform_paths2.transformPaths)(result.data, [
        {
          transformFn: import_image2.transformRESTImageToSDKImage,
          paths: [
            { path: "contact.picture" },
            { path: "contact.info.picture.image" },
            { path: "contact.memberInfo.profileInfo.photo" }
          ]
        },
        {
          transformFn: import_address2.transformRESTAddressToSDKAddress,
          paths: [{ path: "contact.info.addresses.items.address" }]
        }
      ])
    );
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: { contactId: "$[0]", labelKeys: "$[1]" },
        singleArgumentUnchanged: false
      },
      ["contactId", "labelKeys"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
function queryContacts2(options) {
  const { httpClient, sideEffects } = arguments[1];
  return (0, import_query_builder.queryBuilder)({
    func: async (payload) => {
      const reqOpts = queryContacts({
        ...payload,
        ...options ?? {}
      });
      sideEffects?.onSiteCall?.();
      try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return result;
      } catch (err) {
        sideEffects?.onError?.(err);
        throw err;
      }
    },
    requestTransformer: (query) => {
      const args = [query, options];
      return (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
        ...args?.[1],
        query: args?.[0]
      });
    },
    responseTransformer: ({ data }) => {
      const transformedData = (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(
        (0, import_transform_paths2.transformPaths)(data, [
          {
            transformFn: import_image2.transformRESTImageToSDKImage,
            paths: [
              { path: "contacts.picture" },
              { path: "contacts.info.picture.image" },
              { path: "contacts.memberInfo.profileInfo.photo" }
            ]
          },
          {
            transformFn: import_address2.transformRESTAddressToSDKAddress,
            paths: [{ path: "contacts.info.addresses.items.address" }]
          }
        ])
      );
      return {
        items: transformedData?.contacts,
        pagingMetadata: transformedData?.pagingMetadata
      };
    },
    errorTransformer: (err) => {
      const transformedError = (0, import_transform_error.transformError)(err, {
        spreadPathsToArguments: {},
        explicitPathsToArguments: { query: "$[0]" },
        singleArgumentUnchanged: false
      });
      throw transformedError;
    },
    pagingMethod: "OFFSET",
    transformationPaths: {}
  });
}
async function getContact2(_id, options) {
  const { httpClient, sideEffects } = arguments[2];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    id: _id,
    fields: options?.fields,
    fieldsets: options?.fieldsets
  });
  const reqOpts = getContact(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(
      (0, import_transform_paths2.transformPaths)(result.data, [
        {
          transformFn: import_image2.transformRESTImageToSDKImage,
          paths: [
            { path: "contact.picture" },
            { path: "contact.info.picture.image" },
            { path: "contact.memberInfo.profileInfo.photo" }
          ]
        },
        {
          transformFn: import_address2.transformRESTAddressToSDKAddress,
          paths: [{ path: "contact.info.addresses.items.address" }]
        }
      ])
    )?.contact;
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {
          id: "$[0]",
          fields: "$[1].fields",
          fieldsets: "$[1].fieldsets"
        },
        singleArgumentUnchanged: false
      },
      ["_id", "options"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Action,
  AddressTag,
  ContactActivityType,
  ContactFieldSet,
  ContactSourceType,
  ContactsFacetType,
  EmailDeliverabilityStatus,
  EmailTag,
  GetContactResponseType,
  ImageProvider,
  MemberStatus,
  Mode,
  PhoneDeliverabilityStatus,
  PhoneTag,
  PrivacyStatus,
  Role,
  SortOrder,
  SubdivisionType,
  SubmitOperation,
  SubscriptionStatus,
  UpsertContactResponseAction,
  WebhookIdentityType,
  createContact,
  deleteContact,
  getContact,
  labelContact,
  mergeContacts,
  queryContacts,
  unlabelContact,
  updateContact
});
//# sourceMappingURL=index.typings.js.map