"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// meta.ts
var meta_exports = {};
__export(meta_exports, {
  createContact: () => createContact2,
  deleteContact: () => deleteContact2,
  getContact: () => getContact2,
  labelContact: () => labelContact2,
  mergeContacts: () => mergeContacts2,
  queryContacts: () => queryContacts2,
  unlabelContact: () => unlabelContact2,
  updateContact: () => updateContact2
});
module.exports = __toCommonJS(meta_exports);

// src/contacts-v4-contact-contacts.http.ts
var import_rest_modules = require("@wix/sdk-runtime/rest-modules");
var import_float = require("@wix/sdk-runtime/transformations/float");
var import_float2 = require("@wix/sdk-runtime/transformations/float");
var import_timestamp = require("@wix/sdk-runtime/transformations/timestamp");
var import_timestamp2 = require("@wix/sdk-runtime/transformations/timestamp");
var import_field_mask = require("@wix/sdk-runtime/transformations/field-mask");
var import_transform_paths = require("@wix/sdk-runtime/transformations/transform-paths");
var import_rest_modules2 = require("@wix/sdk-runtime/rest-modules");
function resolveComWixpressContactsCoreApiV4ContactsServiceV4Url(opts) {
  const domainToMappings = {
    "www._base_domain_": [
      {
        srcPath: "/_api/contacts/v4/contacts",
        destPath: "/v4/contacts"
      },
      {
        srcPath: "/_api/contacts/v4/bulk",
        destPath: "/v4/bulk"
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/contacts/v4/contacts",
        destPath: "/v4/contacts"
      },
      {
        srcPath: "/contacts/v4/bulk",
        destPath: "/v4/bulk"
      }
    ],
    "manage._base_domain_": [
      {
        srcPath: "/_api/contacts/v4/contacts",
        destPath: "/v4/contacts"
      },
      {
        srcPath: "/_api/contacts/v4/bulk",
        destPath: "/v4/bulk"
      }
    ],
    "manage.nownia.com": [
      {
        srcPath: "/_api/contacts/v4/contacts",
        destPath: "/v4/contacts"
      },
      {
        srcPath: "/_api/contacts/v4/bulk",
        destPath: "/v4/bulk"
      }
    ],
    _: [
      {
        srcPath: "/_api/contacts/v4/bulk",
        destPath: "/v4/bulk"
      },
      {
        srcPath: "/_api/contacts/v4/contacts",
        destPath: "/v4/contacts"
      }
    ],
    "*.dev.wix-code.com": [
      {
        srcPath: "/_api/contacts/v4/bulk",
        destPath: "/v4/bulk"
      },
      {
        srcPath: "/_api/contacts/v4/contacts",
        destPath: "/v4/contacts"
      }
    ]
  };
  return (0, import_rest_modules2.resolveUrl)(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_crm_contacts";
function createContact(payload) {
  function __createContact({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_float.transformSDKFloatToRESTFloat,
        paths: [
          { path: "info.addresses.items.address.geocode.latitude" },
          { path: "info.addresses.items.address.geocode.longitude" }
        ]
      },
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [{ path: "info.picture.image.urlExpirationDate" }]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.contacts.v4.contact",
      method: "POST",
      methodFqn: "com.wixpress.contacts.core.api.v4.ContactsServiceV4.CreateContact",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsCoreApiV4ContactsServiceV4Url({
        protoPath: "/v4/contacts",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "contact.createdDate" },
            { path: "contact.updatedDate" },
            { path: "contact.lastActivity.activityDate" },
            { path: "contact.lastActivity.date" },
            { path: "contact.picture.urlExpirationDate" },
            { path: "contact.info.picture.image.urlExpirationDate" },
            { path: "contact.memberInfo.signupDate" },
            {
              path: "contact.memberInfo.profileInfo.photo.urlExpirationDate"
            },
            { path: "contact.memberInfo.sessionInfo.lastWebLogin" },
            { path: "contact.memberInfo.sessionInfo.lastMobileLogin" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            { path: "contact.info.addresses.items.address.geocode.latitude" },
            {
              path: "contact.info.addresses.items.address.geocode.longitude"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __createContact;
}
function updateContact(payload) {
  function __updateContact({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_field_mask.transformSDKFieldMaskToRESTFieldMask,
        paths: [{ path: "fieldMask" }]
      },
      {
        transformFn: import_float.transformSDKFloatToRESTFloat,
        paths: [
          { path: "info.addresses.items.address.geocode.latitude" },
          { path: "info.addresses.items.address.geocode.longitude" }
        ]
      },
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [{ path: "info.picture.image.urlExpirationDate" }]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.contacts.v4.contact",
      method: "PATCH",
      methodFqn: "com.wixpress.contacts.core.api.v4.ContactsServiceV4.UpdateContact",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsCoreApiV4ContactsServiceV4Url({
        protoPath: "/v4/contacts/{contactId}",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "contact.createdDate" },
            { path: "contact.updatedDate" },
            { path: "contact.lastActivity.activityDate" },
            { path: "contact.lastActivity.date" },
            { path: "contact.picture.urlExpirationDate" },
            { path: "contact.info.picture.image.urlExpirationDate" },
            { path: "contact.memberInfo.signupDate" },
            {
              path: "contact.memberInfo.profileInfo.photo.urlExpirationDate"
            },
            { path: "contact.memberInfo.sessionInfo.lastWebLogin" },
            { path: "contact.memberInfo.sessionInfo.lastMobileLogin" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            { path: "contact.info.addresses.items.address.geocode.latitude" },
            {
              path: "contact.info.addresses.items.address.geocode.longitude"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __updateContact;
}
function mergeContacts(payload) {
  function __mergeContacts({ host }) {
    const metadata = {
      entityFqdn: "wix.contacts.v4.contact",
      method: "POST",
      methodFqn: "com.wixpress.contacts.core.api.v4.ContactsServiceV4.MergeContacts",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsCoreApiV4ContactsServiceV4Url({
        protoPath: "/v4/contacts/{targetContactId}/merge",
        data: payload,
        host
      }),
      data: payload,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "contact.createdDate" },
            { path: "contact.updatedDate" },
            { path: "contact.lastActivity.activityDate" },
            { path: "contact.lastActivity.date" },
            { path: "contact.picture.urlExpirationDate" },
            { path: "contact.info.picture.image.urlExpirationDate" },
            { path: "contact.memberInfo.signupDate" },
            {
              path: "contact.memberInfo.profileInfo.photo.urlExpirationDate"
            },
            { path: "contact.memberInfo.sessionInfo.lastWebLogin" },
            { path: "contact.memberInfo.sessionInfo.lastMobileLogin" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            { path: "contact.info.addresses.items.address.geocode.latitude" },
            {
              path: "contact.info.addresses.items.address.geocode.longitude"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __mergeContacts;
}
function deleteContact(payload) {
  function __deleteContact({ host }) {
    const metadata = {
      entityFqdn: "wix.contacts.v4.contact",
      method: "DELETE",
      methodFqn: "com.wixpress.contacts.core.api.v4.ContactsServiceV4.DeleteContact",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsCoreApiV4ContactsServiceV4Url({
        protoPath: "/v4/contacts/{contactId}",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload)
    };
    return metadata;
  }
  return __deleteContact;
}
function labelContact(payload) {
  function __labelContact({ host }) {
    const metadata = {
      entityFqdn: "wix.contacts.v4.contact",
      method: "POST",
      methodFqn: "com.wixpress.contacts.core.api.v4.ContactsServiceV4.LabelContact",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsCoreApiV4ContactsServiceV4Url({
        protoPath: "/v4/contacts/{contactId}/labels",
        data: payload,
        host
      }),
      data: payload,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "contact.createdDate" },
            { path: "contact.updatedDate" },
            { path: "contact.lastActivity.activityDate" },
            { path: "contact.lastActivity.date" },
            { path: "contact.picture.urlExpirationDate" },
            { path: "contact.info.picture.image.urlExpirationDate" },
            { path: "contact.memberInfo.signupDate" },
            {
              path: "contact.memberInfo.profileInfo.photo.urlExpirationDate"
            },
            { path: "contact.memberInfo.sessionInfo.lastWebLogin" },
            { path: "contact.memberInfo.sessionInfo.lastMobileLogin" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            { path: "contact.info.addresses.items.address.geocode.latitude" },
            {
              path: "contact.info.addresses.items.address.geocode.longitude"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __labelContact;
}
function unlabelContact(payload) {
  function __unlabelContact({ host }) {
    const metadata = {
      entityFqdn: "wix.contacts.v4.contact",
      method: "DELETE",
      methodFqn: "com.wixpress.contacts.core.api.v4.ContactsServiceV4.UnlabelContact",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsCoreApiV4ContactsServiceV4Url({
        protoPath: "/v4/contacts/{contactId}/labels",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload),
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "contact.createdDate" },
            { path: "contact.updatedDate" },
            { path: "contact.lastActivity.activityDate" },
            { path: "contact.lastActivity.date" },
            { path: "contact.picture.urlExpirationDate" },
            { path: "contact.info.picture.image.urlExpirationDate" },
            { path: "contact.memberInfo.signupDate" },
            {
              path: "contact.memberInfo.profileInfo.photo.urlExpirationDate"
            },
            { path: "contact.memberInfo.sessionInfo.lastWebLogin" },
            { path: "contact.memberInfo.sessionInfo.lastMobileLogin" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            { path: "contact.info.addresses.items.address.geocode.latitude" },
            {
              path: "contact.info.addresses.items.address.geocode.longitude"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __unlabelContact;
}
function queryContacts(payload) {
  function __queryContacts({ host }) {
    const metadata = {
      entityFqdn: "wix.contacts.v4.contact",
      method: "POST",
      methodFqn: "com.wixpress.contacts.core.api.v4.ContactsServiceV4.QueryContacts",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsCoreApiV4ContactsServiceV4Url({
        protoPath: "/v4/contacts/query",
        data: payload,
        host
      }),
      data: payload,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "contacts.createdDate" },
            { path: "contacts.updatedDate" },
            { path: "contacts.lastActivity.activityDate" },
            { path: "contacts.lastActivity.date" },
            { path: "contacts.picture.urlExpirationDate" },
            { path: "contacts.info.picture.image.urlExpirationDate" },
            { path: "contacts.memberInfo.signupDate" },
            {
              path: "contacts.memberInfo.profileInfo.photo.urlExpirationDate"
            },
            { path: "contacts.memberInfo.sessionInfo.lastWebLogin" },
            { path: "contacts.memberInfo.sessionInfo.lastMobileLogin" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            {
              path: "contacts.info.addresses.items.address.geocode.latitude"
            },
            {
              path: "contacts.info.addresses.items.address.geocode.longitude"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __queryContacts;
}
function getContact(payload) {
  function __getContact({ host }) {
    const metadata = {
      entityFqdn: "wix.contacts.v4.contact",
      method: "GET",
      methodFqn: "com.wixpress.contacts.core.api.v4.ContactsServiceV4.GetContact",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsCoreApiV4ContactsServiceV4Url({
        protoPath: "/v4/contacts/{id}",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload),
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "contact.createdDate" },
            { path: "contact.updatedDate" },
            { path: "contact.lastActivity.activityDate" },
            { path: "contact.lastActivity.date" },
            { path: "contact.picture.urlExpirationDate" },
            { path: "contact.info.picture.image.urlExpirationDate" },
            { path: "contact.memberInfo.signupDate" },
            {
              path: "contact.memberInfo.profileInfo.photo.urlExpirationDate"
            },
            { path: "contact.memberInfo.sessionInfo.lastWebLogin" },
            { path: "contact.memberInfo.sessionInfo.lastMobileLogin" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            { path: "contact.info.addresses.items.address.geocode.latitude" },
            {
              path: "contact.info.addresses.items.address.geocode.longitude"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __getContact;
}

// src/contacts-v4-contact-contacts.meta.ts
function createContact2() {
  const payload = {};
  const getRequestOptions = createContact(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "POST",
    path: "/v4/contacts",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function updateContact2() {
  const payload = { contactId: ":contactId" };
  const getRequestOptions = updateContact(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "PATCH",
    path: "/v4/contacts/{contactId}",
    pathParams: { contactId: "contactId" },
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function mergeContacts2() {
  const payload = { targetContactId: ":targetContactId" };
  const getRequestOptions = mergeContacts(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "POST",
    path: "/v4/contacts/{targetContactId}/merge",
    pathParams: { targetContactId: "targetContactId" },
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function deleteContact2() {
  const payload = { contactId: ":contactId" };
  const getRequestOptions = deleteContact(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "DELETE",
    path: "/v4/contacts/{contactId}",
    pathParams: { contactId: "contactId" },
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function labelContact2() {
  const payload = { contactId: ":contactId" };
  const getRequestOptions = labelContact(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "POST",
    path: "/v4/contacts/{contactId}/labels",
    pathParams: { contactId: "contactId" },
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function unlabelContact2() {
  const payload = { contactId: ":contactId" };
  const getRequestOptions = unlabelContact(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "DELETE",
    path: "/v4/contacts/{contactId}/labels",
    pathParams: { contactId: "contactId" },
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function queryContacts2() {
  const payload = {};
  const getRequestOptions = queryContacts(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "POST",
    path: "/v4/contacts/query",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function getContact2() {
  const payload = { id: ":id" };
  const getRequestOptions = getContact(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "GET",
    path: "/v4/contacts/{id}",
    pathParams: { id: "id" },
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createContact,
  deleteContact,
  getContact,
  labelContact,
  mergeContacts,
  queryContacts,
  unlabelContact,
  updateContact
});
//# sourceMappingURL=meta.js.map